/*
 * Projrct F-11 - Web SCADA for Java
 * Copyright (C) 2002 Freedom, Inc. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package org.F11.scada.server.alarm.print;

import java.sql.SQLException;
import java.util.ArrayList;

import org.F11.scada.EnvironmentManager;
import org.F11.scada.server.alarm.DataValueChangeEventKey;
import org.apache.log4j.Logger;

/**
 * f[^ύXCxglf[^x[XɊi[Aݒ茏ȏȂJnNX
 * 
 * @author Hideaki Maekawa <frdm@users.sourceforge.jp>
 */
public class AlarmPrintService extends AbstractPrintService {
	/** 1y[WɈs */
	private final int maxLine;
	/** MOAPI */
	private static Logger log = Logger.getLogger(AlarmPrintService.class);

	/**
	 * xT[rX܂Bf[^x[Xɖ̃R[h݂΁ASĎ擾f[^܂B
	 * 
	 * @param printDAO xf[^x[XDAO
	 * @param printer v^[IuWFNg
	 * @throws SQLException f[^x[XG[
	 */
	public AlarmPrintService(AlarmPrintDAO printDAO, AlarmPrinter printer) {
		super(printDAO, printer);
		this.maxLine =
			Integer.parseInt(EnvironmentManager.get(
				"/server/alarm/print/pagelines",
				"10"));
		start();
		log.info("constracted AlarmPrintService.");
	}

	/**
	 * f[^ύXCxgf[^x[XƃXgɒǉ܂ ̃\bh public ɂȂĂ̂́AAcpect
	 * ɂgUNV\ɂׂłB
	 * 
	 * @param key f[^ύXCxg
	 */
	public void insertEvent(DataValueChangeEventKey key) {
		lock.lock();
		try {
			if (printLineDatas == null) {
				// e
				printLineDatas =
					new ArrayList<PrintLineData>(printDAO.findAll());
				print();
			}
			if (printDAO.isAlarmPrint(key)) {
				printDAO.insert(key);
				PrintLineData data = printDAO.find(key);
				printLineDatas.add(data);
				print();
			}
		} catch (SQLException e) {
			log.error("DBG[܂B", e);
		} finally {
			lock.unlock();
		}
	}

	/**
	 * f[^Xg1y[WɈsȏłΈJnB ̌ێf[^Xgƃf[^x[XNA[B
	 * 
	 * @exception SQLException f[^x[XG[
	 */
	private void print() throws SQLException {
		lock.lock();
		try {
			if (maxLine <= printLineDatas.size()) {
				printer.print(printLineDatas);
				printDAO.deleteAll();
				printLineDatas.clear();
			}
		} finally {
			lock.unlock();
		}
	}
}
